/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include	"cmdlib.h"
#include	"mathlib.h"

vec3_t	vec3_origin = {0,0,0};

float DotProduct (float v1[3], float v2[3])
{
	float dotret;

	__asm
	{
		mov				ecx, v1
		mov				eax, v2

		fld		dword	ptr	[eax+0]
		fmul	dword	ptr	[ecx+0]
		fld		dword	ptr	[eax+4]
		fmul	dword	ptr	[ecx+4]
		fld		dword	ptr	[eax+8]
		fmul	dword	ptr	[ecx+8]
		fxch            st(1)
		faddp           st(2),st(0)
		faddp           st(1),st(0)
		fstp	dword	ptr	[dotret]
	}

	return dotret;
}

void VectorNormalize (vec3_t v)
{
	float length = DotProduct (v,v);

	if (length)
	{
		length = (float)(sqrt (length));

		length = 1/length;

		VectorScale (v, length, v);
	}
}